﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;
using Infragistics.Controls.Grids.Primitives;

namespace XamGridGroupBy
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            List<Person> data = new List<Person>();
            data.Add(new Person() { Name = "person1", Age = 20 });
            data.Add(new Person() { Name = "person1", Age = 30 });
            data.Add(new Person() { Name = "person2", Age = 40 });
            data.Add(new Person() { Name = "person2", Age = 50 });
            data.Add(new Person() { Name = "person1", Age = 60 });

            xamGrid1.DataContext = data;

        }

        private void xamGrid1_Loaded(object sender, RoutedEventArgs e)
        {
            xamGrid1.GroupBySettings.AllowGroupByArea = Infragistics.Controls.Grids.GroupByAreaLocation.Top;
            xamGrid1.GroupBySettings.GroupByColumns.Add(xamGrid1.Columns[0] as Column);
        }

        private void xamGrid1_GroupByCollectionChanged(object sender, GroupByCollectionChangedEventArgs e)
        {
            Dispatcher.BeginInvoke(new Action(() => 
            {
                var tmp = this.GetChildFromType<GroupByHeaderCellControl>(xamGrid1);
                (tmp as GroupByHeaderCellControl).Visibility = System.Windows.Visibility.Collapsed;
            }));
        }

        private T GetChildFromType<T>(DependencyObject parent) where T : DependencyObject
        {
            T result = null;

            for (int i = 0; i < VisualTreeHelper.GetChildrenCount(parent); i++)
            {
                if (VisualTreeHelper.GetChild(parent, i) is T)
                {
                    return VisualTreeHelper.GetChild(parent, i) as T;
                }
                else
                {
                    result = GetChildFromType<T>(VisualTreeHelper.GetChild(parent, i));

                    if (result != null)
                    {
                        break;
                    }
                }
            }
            return result;
        }
    }

    public class Person
    {
        public string Name { get; set; }
        public int Age { get; set; }
    }
}
